<?php
/**
* admin.noah.php
* Traduzido por Filipe Torres em 10/10/2006
* @package Noah Classifieds Joomla!/Mambo Component
* @version 1.0 - admin
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

// Don't allow direct access
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

require_once( $mainframe->getPath( 'admin_html' ) );
require_once( $mainframe->getPath( 'class' ) ); 

require_once( dirname(__FILE__) . "/dbupgrade.php" );

switch ($task) {

	case "settings":
		NoahClass::ShowSettings();
		break;
	case "save":
		$msg = NoahClass::SaveSettings();
		mosRedirect("index2.php?option=com_noah", $msg);
		break;
	case "goBack":
	case "";
	case "cancel":
	default:
		NoahClass_HTML::ShowInfo();
		break;	
	case "testing":
	    break;
}


class NoahClass {
	
	function ShowSettings() {
		global $database;
		
		$noahSet = new NoahClass_Settings($database);
		$noahSet->getSettings();
		
		NoahClass_HTML::showSettings($noahSet);
		
	}
	
	function SaveSettings() {
		
		global $database;
		
		$msg = "";
		
		$noahSet = new NoahClass_Settings($database);
		$noahSet->getSettings();
		
		$numFields = $noahSet->numfields;
		
		$noahSet->bind($_POST);
		
		if ($numFields > $noahSet->numfields) {
			$msg .= "ERRO: Voc no pode reduzir o nmero de campos de variveis (variable fields).";
			$noahSet->numfields = $numFields;
		}
		
		if ($noahSet->store() === true) {
			// Update the database tables based on the number of fields		
			if (!updateVariableTables($database, $noahSet->numfields)) {
				$msg .= "ERRO: a tabela no foi atualizada corretamente.";
			} else {
				$msg .= "Ajustes salvas com sucesso!";
			}
		} else {
			$msg .= "ERRO: Ajustes no salvos.";
		}
		
		return $msg;

	}	
	
	
}


?>
