<?php
/**
* checkconf.php
* @package Noah Classifieds Joomla!/Mambo Component
* @version 1.0
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

// Don't allow direct access
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

require_once($mosConfig_absolute_path . "/administrator/components/com_noah/dbupgrade.php");

function checkConf()
{
    global $gorumroll,$lll,$gorumuser, $gorumglobalstat;
    global $database;
    $s="";
    $b="<br><br>\n";

    $g=new globalsettings;
    $g->load();
    if ($g->settings_adminEmail=="system@system.system") {
        $s.="<span class='conferr'>".$lll["chsyspass"].
            "</span><br><br>\n";
    }

    if( !defined("IMG_GIF") || !function_exists("ImageTypes"))//nincs GD
    {
        $s.="<span class='conferr'>".$lll["nogd"].
            "</span><br>\n";
        $s.="<span class='confexpl'>".$lll["nogd_expl"].
            "</span><br><br>\n";
    }
    global $adAttLocalDir, $catAttLocalDir;
    $f1name = mosPathName($adAttLocalDir, true) ."test1";
    $f2name = mosPathName($catAttLocalDir, true) . "test2";
    $f1 = @fopen($f1name,"w");
    $f2 = @fopen($f2name,"w");
    
    if (file_exists($f1name)) {
		$rgStat = stat($f1name);
		$f1mode = $rgStat['mode'];
		$strMode1 = sprintf("mode - %o", $f1mode);
	} else {
		$strMode1 = "test file does not exist";
	}
	
	if (file_exists($f2name)) {
		$rgStat = stat($f2name);
		$f2mode = $rgStat['mode'];
		$strMode2 = sprintf("mode - %o", $f2mode);
	} else {
		$strMode2 = "test file does not exist";
	}

	$strMode = "";
	
	if (file_exists($adAttLocalDir)) {
		$rgStat = stat($adAttLocalDir);
		$dmode = $rgStat['mode'];
		// $strMode = sprintf("%s mode - %o", $adAttLocalDir, $dmode);
	} else {
		$strMode = "$adAttLocalDir does not exist";
	}
	
	if ($strMode != "") {
		$s .= "<span class='conferr'>";
		$s .= $strMode;
		$s .= "</span><br/>";
	}
		
	if (file_exists($catAttLocalDir)) {
		$rgStat = stat($catAttLocalDir);
		$dmode = $rgStat['mode'];
		// $strMode = sprintf("%s mode - %o", $catAttLocalDir, $dmode);
	} else {
		$strMode = "$catAttLocalDir does not exist";
	}

	if ($strMode != "") {
		$s .= "<span class='conferr'>";
		$s .= $strMode;
		$s .= "</span><br/>";
	}
/**
    if (!$f1){
		$s .= "<span class='conferr'>f1 failure - $f1name<br/>";
		$s .= $strMode1;
		$s .= "</span><br/>";
	}
	
    if (!$f2){
		$s .= "<span class='conferr'>f2 failure - $f2name<br/>";
		$s .= $strMode2;
		$s .= "</span><br/>";
	}
*/
    if( !$f1 || !$f2 )
    {
        $s.="<span class='conferr'>".$lll["nopermission"].
            "</span><br>\n";
        $s.="<span class='confexpl'>".$lll["nopermission_expl"].
            "</span><br><br>\n";
    }
    @fclose( $f1 );
    @fclose( $f2 );
    
    // Clean up after ourselves
    @unlink( $f1name );
    @unlink( $f2name );
   
    if ($gorumglobalstat->defPageConf) {
        $s.="$lll[confdisapp] ";
        $tempRoll = clone($gorumroll);
        $tempRoll->method = "remove_first_check";
        $s.=$tempRoll->generAnchor($lll["here1"]);
        $s.=".<br>$lll[confclicheck]";
    }
    
    if (!Noah_FUpgradeDatabaseTables($errMsg)) {
		$s .= $errMsg . "<br/>";
	}

	if ($s == "") {
		// No Error
		$s = "<span class='confok'>" . $lll["conf_ok"] ."</span>";
	}
	    
    $s1 = "<table border='0' cellpadding='20'><tr><td class='cell'>\n";
    if ($gorumglobalstat->congrat) {
        $s1.="<center><b>$lll[congrat]</b></center>$b";
        $gorumglobalstat->congrat = FALSE;
        modify($gorumglobalstat);
    }
    $s1 .= "<b>$lll[confcheck]</b>$b";
	$s = $s1 . $s;

    $s.="</td></tr></table>";
    return $s;
}
function removeFirstCheck()
{
    global $whatHappened;
    global $gorumglobalstat;
    $gorumglobalstat->defPageConf=FALSE;
    modify($gorumglobalstat);
    $whatHappened="form_submitted";
}
?>
