<?php
/**
* init.php
* @package Noah Classifieds Mambo Component
* @version 1.0
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

// Don't allow direct access
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );


define('cItemsMaxPerRow', 5);

class init
{
function initializeSystemSettings()
{
    global $gorumroll,$lll;

    //hackImageInput();
    $gorumroll = new roll;
    $gorumroll->create();
    authenticate(); 
    $this->initializeUserSettings();
    global $FLOOD;
    if (isset($FLOOD) && $gorumroll->submit!=$lll["cancel"]) {
        if (isset($_POST["flood"])) {
            floodCheck($_POST["flood"]);
        }
        if (isset($_GET["flood"])) {
            floodCheck($_GET["flood"]);
        }
    }
    if( class_exists("badwords") )
    {
        global $gorumbadwords;
        $gorumbadwords = new badwords;
        loadObjectsSql( $gorumbadwords, "", $gorumbadwords );
    }
    if( class_exists("cronjob") )
    {
        executeCronJobs();
    }
    if( class_exists("reflog") ) {
        $log = new reflog;
        $log->create();
    }
    if( class_exists("statlog") ) {
        $log = new statlog;
        $log->create();
    }
}
    
function initializeUserSettings()
{
    global $lll;//A lang file beli lll miatt, ne torold!
    global $emailAccount, $user_typ;
	global $stNoahDir;
	
    if( class_exists("globalsettings") )
    {
        $globalSettings = new globalsettings;
        $globalSettings->load();
        $globalSettings->initGlobals();
    }
	global $mosConfig_lang;
	
	if (file_exists($stNoahDir .'./gorum/lang/'.$mosConfig_lang.'.php')) {
		include_once($stNoahDir .'./gorum/lang/'.$mosConfig_lang.'.php');
		} else {
		include_once($stNoahDir .'./gorum/lang/english.php');
	}
	if (file_exists($stNoahDir .'./lang/'.$mosConfig_lang.'.php')) {
		include_once($stNoahDir .'./lang/'.$mosConfig_lang.'.php');
		} else {
		include_once($stNoahDir .'./lang/english.php');
	}

    //@include("./../../lang/$languageFile");TODO
    if( function_exists("postLangInclude") ) postLangInclude();
    if( $emailAccount )
    {
        $user_typ["attributes"]["email"][]="modify_form: readonly";
        $user_typ["attributes"]["name"][]="login_form: form invisible";
        $user_typ["unique_keys"]="email";
        $lll["user_name"]=$lll["user_displayName"];
        $lll["userAllreadyExists"]=$lll["userAllreadyExistsWithName"];
    }
    else
    {
        $user_typ["attributes"]["name"][]="modify_form: readonly";
        $user_typ["attributes"]["email"][]="login_form: form invisible";
    }
}

function outputHtmlHead()
{
    global $headTemplate,$htmlTitle,$htmlKeywords,$htmlDescription;
    global $applName,$language;

	global $mainframe;

	if ($htmlTitle)	
		$mainframe->setPageTitle($htmlTitle);
	
	$s = "";
    $s.="$headTemplate\n";
    $mainframe->addCustomHeadTag($this->showCss());

}

function showCss()
{
    global $fixCss;
    $s="";
    if ($fixCss) {
        if ($fixCss=="no") {
            $s="";
        }
        else {
            $s.="<link rel='StyleSheet' href='$fixCss' type='text/css' />\n";
        }
    }
    else {
        $ss = new stylesheet;
        $ss->id=1;
        load($ss);
        $s.="<style type='text/css'>\n".$ss->css."</style>\n";
    }
    return $s;
}

function generBoxUp($tableWidth="100%",$cp="2",$line="line",
                    $boxframe="boxframe")
{
    global $boxWithFrame,$boxShadow;
    $s="";

    $w = $tableWidth;
    if ($boxShadow) {
        $s.="<table border='0' width='$tableWidth' cellpadding='0'".
            " cellspacing='0'>";
        $s.="<tr><td>";
        $w="100%";
    }
    if ($boxWithFrame) {
        $s.="<table border='0' class='$boxframe' width='$w'".
            " cellpadding='0' cellspacing='0'><tr><td>\n";
        $s.="<table border='0' width='100%' cellpadding='0'".
            " cellspacing='1'><tr><td>\n";
        $w="100%";
    }
    $s.="<table border='0' class='$line' width='$w'".
        " cellpadding='0' cellspacing='0'><tr><td>\n";
    $s.="<table border='0' width='100%' cellpadding='$cp'".
        " cellspacing='1'>\n";
    return $s;
}

function generBoxDown()
{
    global $boxWithFrame,$xi,$boxShadow;
    $s="";
    //ezt a ket sort lehet, hogy forditva kellene irni
    if ($boxWithFrame) $s.="\n</td></tr></table>\n</td></tr></table>\n";
    $s.="\n</table>\n</td></tr></table>\n";
    if ($boxShadow) {
        $s.="</td>";
        $s.="<tr><td background='$xi/boxshadow.gif'>".
            "<img src='$xi/b.gif' height='4'></td></tr></table>";
    }
    return $s;
}

function showApp()
{
    global $gorumcontent,$navBarText,$infoText;
    global $upperTemplate,$lowerTemplate,$lll;
    global $gorumrecognised,$gorumuser;

    
    $s="";
    $s.="<tr><td valign='top' align='center' width='90%'>\n";
    $s.=generBoxUp("100");
    $s.="<tr class='cell'>\n";
    $this->makeUserMenu($userMenu, "menu");
    $s.=$this->showUserMenu($userMenu);
    $s.="</tr>\n";
    $s.=generBoxDown();
    $s.="</td></tr>\n";

    if( $gorumrecognised  && $gorumuser->isAdm) {
        $s.="<tr><td valign='top' align='center' width='90%'>\n";
        $s.=generBoxUp("100");
        $s.="<tr class='cell'>\n";
        $this->makeAdminMenu($adminMenu, "menu");
        $s.=$this->showAdminMenu($adminMenu);
        $s.="</tr>\n";
        $s.=generBoxDown();
        $s.="</td></tr>\n";
    }
    
    if( $navBarText ) {
        $s.="<tr><td valign='top' align='center' width='90%'>\n";
        $s.="<br>$navBarText\n";
        $s.="</td></tr>\n";
    }    
    if( $infoText ) {
        $s.="<tr><td valign='top' align='center' width='90%'>\n";
        $s.="<br><span class='messageLine'>$infoText</span>\n";
        $s.="</td></tr>\n";
    }
    $s.="<tr><td valign='top' align='center' width='90%'>\n";
    $s.=$gorumcontent;  
    $s.="</td></tr></table>\n";
    $s.=$this->showVersionFooter();
    return $s;
}

// Ezt a fg-t mindenkeppen felul kell irni a leszarmaztatott osztalyban:
function showVersionFooter()
{
    return "<br><center><font color='#888888' size='-1'>General application platform from ".
           "PhpOutsourcing</font></center>\n";
}

function showUserStatus()
{
    global $gorumuser,$gorumrecognised,$gorumroll,$lll;
    $s="";
    if ($gorumrecognised) {
        $s.=sprintf($lll["loggedinas"],
                htmlspecialchars($gorumuser->name));
    }
    else {
        $s.=$lll["regorlog"];
    }
    $s.="\n";
    return $s;
}

// A menupontok kirakasanak legegyszerubb alapesete. Ha maskepp akarjuk,
// akkor ezeket a fg-eket felul kell irni:
function showLoginMenu($menu)
{
    $s="";
    foreach($menu as $id=>$menuPoint) {
        $s.="<td nowrap>$menuPoint</td>\n";
    }
    return $s;
}

function showUserMenu($menu)
{
    $s="";
    foreach($menu as $id=>$menuPoint) {
        $s.="<td nowrap>$menuPoint</td>\n";
    }
    return $s;
}


function showAdminMenu($menu)
{
    $s="";
    $i = 0;
    foreach($menu as $id=>$menuPoint) {
		// We need to limit the number of menu items on a row
        if ($i >= cItemsMaxPerRow)
        {
			$s .= "</tr><tr>";
			$i = 0;
		}
        $s.="<td nowrap='nowrap'>$menuPoint</td>\n";
        $i++;
    }
    return $s;
}

// Ez a fg hatarozza meg, hogy mely menupont milyen feltetellel lesz 
// kirakva. Ha az applikacioban uj menupontokat akarunk felvenni, vagy
// elvenni a menupontokbol, vagy mas feltetelhez kotni a kirakasukat,
// ezt a fg-t kell felulirni
function display( $what )
{
    global $itemClassName, $categoryClassName, $gorumroll;
    global $gorumrecognised, $fixCss, $immediateAppear;
    
    hasAdminRights($isAdm);
    switch( $what )
    {
    case Init_register:
        return !$gorumrecognised;
    case Init_login:
        return !$gorumrecognised;
    case Init_myProfile:
        return $gorumrecognised;
    case Init_myItems:
        return $gorumrecognised && class_exists("item");    
    case Init_addItem:
        return $gorumrecognised && class_exists("item") && 
               $gorumroll->list==$categoryClassName && 
               $gorumroll->method=="showhtmllist" && $gorumroll->rollid;    
    case Init_recentItems:
        return class_exists("item");
    case Init_popularItems:
        return class_exists("item");
    case Init_search:
        return $gorumrecognised && class_exists("search");
    case Init_home:
        return TRUE;
    case Init_settings:
        return $isAdm && class_exists("globalsettings");
    case Init_modStyle:
        return $isAdm && !isset($fixCss);
    case Init_userList:
        return $isAdm;
    case Init_badWords:
        return $isAdm && class_exists("badwords");
    case Init_activeItems:
        return $isAdm && class_exists("item") && !$immediateAppear;
    case Init_inactiveItems:
        return $isAdm && class_exists("item") && !$immediateAppear;
    case Init_cronjobs:
        return FALSE;
    case Init_notifications:
        return $isAdm && class_exists("notification");
    case Init_addCategory:
        return $isAdm && isset($categoryClassName) && 
               $gorumroll->list==$categoryClassName &&
               $gorumroll->method=="showhtmllist";
    case Init_modCategory:
        return $isAdm && isset($categoryClassName) && $gorumroll->rollid 
               && $gorumroll->list==$categoryClassName &&
               $gorumroll->method=="showhtmllist";
    case Init_delCategory:
        return $isAdm && isset($categoryClassName) && $gorumroll->rollid 
               && $gorumroll->list==$categoryClassName &&
               $gorumroll->method=="showhtmllist";
    default:
        return FALSE;           
    }
}

// A display fg altal megszabott feltetelek alapjan kitolti a $menu 
// tombot:
function makeLoginMenu(&$menu, $spanCl="")
{
    global $gorumuser, $gorumroll;
    global $gorumauthlevel, $gorumrecognised;
    global $necessaryAuthLevel;
    global $lll;

    $menu=array();
    if( $this->display( Init_register ))
    {
        $st = '<a href="'. sefRelToAbs('index.php?option=com_registration&task=register') .'"';
        if ($spanCl) {
			$st .= " class='$spanCl'";
		}
		$st .= '>'. $lll["register"] .'</a>';
        $menu[Init_register]=$st;
    }
    if( $this->display( Init_login ))
    {
		// The &task=login is superfluous, but avoids being told we're not authorized
		// to view that resource
        $st = '<a href="'. sefRelToAbs('index.php?option=com_login&task=login') .'"';
        if ($spanCl) {
			$st .= " class='$spanCl'";
		}
		$st .= '>'. $lll["login"] .'</a>';
		$menu[Init_login]= $st;
    }

}

// A display fg altal megszabott feltetelek alapjan kitolti a $menu 
// tombot:
function makeUserMenu(&$menu, $spanCl="")
{
    global $gorumroll,$gorumuser,$lll;
    global $itemClassName, $categoryClassName, $searchClassName;

    $menu=array();

    // My items:
    if( $this->display( Init_myItems ))
    {
        $tempRoll = clone($gorumroll);
        $tempRoll->list = $itemClassName."_my";
        $tempRoll->method = "showhtmllist";   
        $tempRoll->rollid = 0;   
        $menu[Init_myItems]=$tempRoll->generAnchor($lll[$itemClassName."_my"], $spanCl);        
    }
    // Add item:
    if( $this->display( Init_addItem ))
    {
        $n = new $itemClassName;
        $tempRoll = clone($gorumroll);
        $tempRoll->list = $itemClassName;
        $tempRoll->class = $itemClassName;
        $tempRoll->method = "create_form";   
        $tempRoll->rollid = 0;   
        saveInFrom($tempRoll);
        $n->showNewToolPlusUrl($tempRoll);
        $label=$lll[$itemClassName."_newitem"];
        $menu[Init_addItem]=$tempRoll->generAnchor($label, $spanCl);   
    }
    // Recent added items:
    if( $this->display( Init_recentItems ))
    {
        $tempRoll = clone($gorumroll);
        $tempRoll->list = $itemClassName."_active";
        $tempRoll->method = "showhtmllist";   
        $tempRoll->rollid = 0;   
        $menu[Init_recentItems]=$tempRoll->generAnchor($lll[$itemClassName."_recent"], $spanCl); 
    }       
    // Most popular items:
    if( $this->display( Init_popularItems ))
    {
        $tempRoll = clone($gorumroll);
        $tempRoll->list = $itemClassName."_popular";
        $tempRoll->method = "showhtmllist";   
        $tempRoll->rollid = 0;   
        $menu[Init_popularItems]=$tempRoll->generAnchor($lll[$itemClassName."_popular"], $spanCl);  
    }      
    // Search form:
    if( $this->display( Init_search ))
    {
        $tempRoll = clone($gorumroll);
        $tempRoll->list = $searchClassName;
        $tempRoll->method = "create_form";   
        $tempRoll->rollid = 0;   
        saveInFrom($tempRoll);
        $menu[Init_search]=$tempRoll->generAnchor($lll["search"], $spanCl);        
    }
     // Home link:
     if( $this->display( Init_home ))
     {
        $tempRoll = clone($gorumroll);
        $tempRoll->list = "";
        $tempRoll->method = "";   
        $tempRoll->fromlist = "";
        $tempRoll->frommethod = "";
        $tempRoll->fromid = "";
        $tempRoll->fromfromlist = "";
        $tempRoll->fromfrommethod = "";
        $tempRoll->fromfromid = "";
        $tempRoll->rollid = 0;   
        global $defaultMethod;
        if ($defaultMethod=="showhtmllist") {
            $tempRoll->clearoff = 1;
        }
        $menu[Init_home]=$tempRoll->generAnchor($lll["home"], $spanCl);
    }}

// A display fg altal megszabott feltetelek alapjan kitolti a $menu 
// tombot:
function makeAdminMenu(&$menu, $spanCl="")
{
    global $gorumroll,$lll,$immediateAppear, $itemClassName; 
    global $categoryClassName;

    $menu=array();
    // Settings:
    if( $this->display( Init_settings ))
    {
        $tempRoll = clone($gorumroll);
        $tempRoll->list = "globalsettings";        
        $tempRoll->method = "modify_form";   
        $tempRoll->rollid = 0;   
        saveInFrom($tempRoll);
        $menu[Init_settings]=$tempRoll->generAnchor($lll["adminsett"], $spanCl);        
    }
    // Modify style:
    if( $this->display( Init_modStyle ))
    {
        $tempRoll = clone($gorumroll);
        $tempRoll->list = "stylesheet";
        $tempRoll->method = "modify_form";   
        $tempRoll->rollid = 1;   
        $menu[Init_modStyle]=$tempRoll->generAnchor($lll["modcss"], $spanCl);        
    }
    // Bad words:
    if( $this->display( Init_badWords ))
    {
        $tempRoll = clone($gorumroll);
        $tempRoll->list = "badwords";
        $tempRoll->method = "showhtmllist";
        $tempRoll->rollid = 0;
        $menu[Init_badWords]=$tempRoll->generAnchor($lll["BadWords"],$spanCl);
    }
    // Approved items:
    if( $this->display( Init_activeItems ))
    {
        $tempRoll = clone($gorumroll);
        $tempRoll->list = $itemClassName."_active";
        $tempRoll->method = "showhtmllist";
        $tempRoll->rollid = 0;
        $menu[Init_activeItems]=$tempRoll->generAnchor($lll[$itemClassName."_Active"],$spanCl);
    }    
    // Pending items:
    if( $this->display( Init_inactiveItems ))
    {
        $tempRoll = clone($gorumroll);
        $tempRoll->list = $itemClassName."_inactive";
        $tempRoll->method = "showhtmllist";
        $tempRoll->rollid = 0;
        $menu[Init_inactiveItems]=$tempRoll->generAnchor($lll[$itemClassName."_Inctive"],$spanCl);
    }
    // Cronjobs:
    if( $this->display( Init_cronjobs ))
    {
        $tempRoll = clone($gorumroll);
        $tempRoll->list = "cronjob";
        $tempRoll->method = "showhtmllist";
        $tempRoll->rollid = 0;
        $menu[Init_cronjobs]=$tempRoll->generAnchor($lll["Cronjobs"],$spanCl);
    }
    // Notifications:
    if( $this->display( Init_notifications ))
    {
        $tempRoll = clone($gorumroll);
        $tempRoll->list = "notification";
        $tempRoll->method = "showhtmllist";
        $tempRoll->rollid = 0;
        $menu[Init_notifications]=$tempRoll->generAnchor($lll["Notifications"],$spanCl);
    }    
    // Create category:
    if( $this->display( Init_addCategory ))
    {
        $c = new $categoryClassName;
        $tempRoll = clone($gorumroll);
        $tempRoll->class = $categoryClassName;
        $tempRoll->method = "create_form";   
        $tempRoll->rollid = 0;   
        saveInFrom($tempRoll);
        $c->showNewToolPlusUrl($tempRoll);
        $label=$lll[$categoryClassName."_newitem"];
        $menu[Init_addCategory]=$tempRoll->generAnchor($lll[$categoryClassName."_newitem"], $spanCl);        
    }
    // Modify category:
    if( $this->display( Init_modCategory ))
    {
        $tempRoll = clone($gorumroll);
        $tempRoll->list = $categoryClassName;
        $tempRoll->method = "modify_form";
        $tempRoll->id = $gorumroll->rollid;
        saveInFrom($tempRoll);
        $menu[Init_modCategory]=$tempRoll->generAnchor($lll[$categoryClassName."_mod"],$spanCl);
    }
    // Delete category:
    if( $this->display( Init_delCategory ))
    {
        $tempRoll = clone($gorumroll);
        $tempRoll->list = $categoryClassName;
        $tempRoll->method = "delete_form";
        $tempRoll->id = $gorumroll->rollid;
        saveInFrom($tempRoll);
        $menu[Init_delCategory]=$tempRoll->generAnchor($lll[$categoryClassName."_del"],$spanCl);
    }
}


function showNavBar()
{
    return "";
}     

// A leszarmazott irja felul:
function getTemplate()
{
}     

// A leszarmazott irja felul:
function getTemplateAfter()
{
}     

}
function hackImageInput()
{
    global $lll;

    if (isset($_POST["cancel_x"])) {
        $_POST["submit"]="Cancel";//TODO: internacion.
    }
}
//Ez direkt nincs az osztalyban!
function showPopupHelp()
{
    global $_GET,$lll;
    
    $helpText = $_GET["expl"];
    $helpTitle = $_GET["title"];
    if( function_exists("showAppPopupHelp") ) 
    {
        showAppPopupHelp($helpTitle, $helpText);
    }
    else
    {    
        echo "<center><b>$helpTitle</b></center><br><br>\n";
        echo $helpText;
        die();
    }    
}
/*
Ezt a fuggvenyt csak azert nem torlom ki, mert annyira szep!

function regGlob(&$a,$vn,$e="")
{
    global $_GET,$HTTP_POST_VARS,$HTTP_COOKIE_VARS;
    foreach($a as $key=>$val) {
        if (is_array($val) && get_magic_quotes_gpc()) {
            regGlob($val,$vn,$e."['$key']");
        }
        else {
            if (get_magic_quotes_gpc()) {
                $command="\$GLOBALS$e"."['$key']=".
                         "stripslashes(\$$vn$e"."['$key']);";
            }
            else {
                $command="\$GLOBALS$e"."['$key']=".
                         "(\$$vn$e"."['$key']);";
            }
            //echo "comm:$command.<br>\n";
            eval($command);
        }
    }
}
*/
?>
