<?php
/**
* admin.noah.php
* @package Noah Classifieds Joomla!/Mambo Component
* @version 1.0 - admin
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

// Don't allow direct access
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

class NoahClass_Settings {
	var $_db;
	var $numfields;
	var $payclasspath;
	var $nopostingmsg;
	var $noviewingmsg;
	
	function NoahClass_Settings(&$db) {	
		$this->_db =& $db;
	}
	
	function getSettings() {
		$stQuery = "SELECT * FROM #__noahads_settings LIMIT 1";
		
		$this->_db->setQuery($stQuery);
		$this->_db->loadObject($this);
	}
	
	function bind($array) {
		return mosBindArrayToObject( $array, $this, '');
	}
	
	function store($updateNulls = false) {
		$table = "#__noahads_settings";
		// Modified version of database updateObject for no key
		$fmtsql = "UPDATE $table SET %s";
		$tmp = array();
		$object =& $this;
		foreach (get_object_vars( $object ) as $k => $v) {
			if( is_array($v) or is_object($v) or $k[0] == '_' ) { // internal or NA field
				continue;
			}
			if ($v === NULL && !$updateNulls) {
				continue;
			}
			if( $v == '' ) {
				$val = "''";
			} else {
				$val = $this->_db->Quote( $v );
			}
			$tmp[] = $this->_db->NameQuote( $k ) . '=' . $val;
		}
		$this->_db->setQuery( sprintf( $fmtsql, implode( ",", $tmp ) ) );
		return $this->_db->query();
	}

	
}

?>