<?php
/**
* response.php
* @package Noah Classifieds Mambo Component
* @version 1.0
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

// Don't allow direct access
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

$response_typ =  
    array(
        "attributes"=>array(   
            "id"=>array(
                "type"=>"INT",
                "auto increment",
                "form hidden"
            ),            
            "yourname"=>array(
                "type"=>"VARCHAR",
                "text",
                "max" =>"250"
            ),
            "youremail"=>array(
                "type"=>"VARCHAR",
                "min"=>"1",
                "mandatory",
                "text",
                "max" =>"250"
            ),
            "mess"=>array(
                "type"=>"TEXT",
                "textarea",
                "cols"=>"40",
                "rows"=>"10"
            ),
        ),    
        "primary_key"=>"id"
    );
class response extends Object
{
function hasObjectRights(&$hasRight, $method, $giveError=FALSE)
{
    $generalRight = TRUE;
    $hasRight=TRUE;
}  
function create()
{
    global $whatHappened,$lll,$adminEmail,$gorumroll,$database;
    global $itemClassName, $webSiteUrl, $replyToAddress;
    global $guestreplyto, $scriptName;
    
    if( !isset($webSiteUrl) ) $webSiteUrl="";
    $this->valid();
    if( $whatHappened=="invalid_form" )
    {
        return ;
    }
    
    global $my;
    
    // If guests are not allowed to reply, don't let them sneak in
    if ($my->id == 0 && !$guestreplyto)
    {
		return;
	}
    
    $a = new $itemClassName;
    $a->id = $gorumroll->rollid;
    load($a);
    $a->responded++;
    modify($a);
    $u = new mosUser($database);
    $u->load($a->ownerId);
    $n = new notification;
    $n->id = Notification_adReply;
    $n->load();
    if( $n->active )
    {
        $tempRoll = new roll;
        $tempRoll->list = $itemClassName;
        $tempRoll->method = "showdetails";   
        $tempRoll->rollid = $gorumroll->rollid;   
        $url = $tempRoll->makeUrl("mixed");

        $sp = new SendingParameters;
        $sp->to = $u->email;
        $sp->replyTo = $this->youremail; 
        $n->send( $sp, $a->title,$url, $this->yourname,
                    $this->youremail,$this->mess); // TODO:url
    }
    //TODO: respnum increase
    mosRedirect($scriptName, $lll["mail_sent"]);
    die();
} 
}

//---------------------------------------------------------------------
//---------------------------------------------------------------------
//---------------------------------------------------------------------

$friendmail_typ =  
    array(
        "attributes"=>array(   
            "id"=>array(
                "type"=>"INT",
                "auto increment",
                "form hidden"
            ),            
            "yourname"=>array(
                "type"=>"VARCHAR",
                "text",
                "max" =>"250"
            ),
            "youremail"=>array(
                "type"=>"VARCHAR",
                "min"=>"1",
                "mandatory",
                "text",
                "max" =>"250"
            ),
            /*
            "friendsname"=>array(
                "type"=>"VARCHAR",
                "text",
                "max" =>"250"
            ),
            */
            "friendsemail"=>array(
                "type"=>"VARCHAR",
                "min"=>"1",
                "mandatory",
                "text",
                "max" =>"250"
            ),
            "mess"=>array(
                "type"=>"TEXT",
                "textarea",
                "cols"=>"40",
                "rows"=>"10"
            ),
        ),    
        "primary_key"=>"id"
    );
class friendmail extends Object
{
function hasObjectRights(&$hasRight, $method, $giveError=FALSE)
{
    $generalRight = TRUE;
    $hasRight=TRUE;
}  
function create()
{
    global $whatHappened,$lll,$adminEmail,$gorumroll;
    global $itemClassName;
	global $guestemailfriend;
	global $scriptName;
		    
    $this->valid();
    if( $whatHappened=="invalid_form" )
    {
        return ;
    }
    
    global $my;
    // If guests are not allowed to email friends, don't let them sneak in
    if ($my->id == 0 && !$guestemailfriend)
    {
		return;
	}
    $n = new notification;
    $n->id = Notification_adToAFriend;
    $n->load();
    if( $n->active )
    {
        $tempRoll = new roll;
        $tempRoll->list = $itemClassName;
        $tempRoll->method = "showdetails";   
        $tempRoll->rollid = $gorumroll->rollid;   
        $url = $tempRoll->makeUrl("mixed");
        
        $sp = new SendingParameters;
        $sp->to = $this->friendsemail;
        $sp->replyTo = $this->youremail; 
        $n->send( $sp, $this->yourname,
                  $url,$this->mess); 
    }
    //TODO: respnum increase
    mosRedirect($scriptName, $lll["mail_fr_sent"]);
    die();
} 
}
?>