<?php
/**
* constants.php
* @package Noah Classifieds Mambo Component
* @version 1.0
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* @traduo: Filipe Torres
*/

// Don't allow direct access
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

define('_NOAH_COMPONENT_VERSION', "1.0 Beta 4");
$stNoahHttpDir = $mosConfig_live_site . "/components/com_noah/";
$xi=$stNoahHttpDir . "i";

// Outras variveis que voc pode alterar so:
$boxWithFrame=FALSE;
$mainBoxWidth="100%";
$mainBoxPadding="6";
// Diretrios para anncios enviados e imagens de categorias:
// A verso Alfa deste componente guardava no diretrio do componente
// e estes diretrios eram apagados gquando o componente era desinstalado.
// Para melhorar o upgrade, as imagens agora so movidas para um diretrio
// fora do diretrio raz do Joomla.
$adAttDir= $mosConfig_live_site . "/noah_pics/listings";
$adAttLocalDir = $mosConfig_absolute_path . "/noah_pics/listings";
$catAttDir= $mosConfig_live_site . "/noah_pics/cats";
$catAttLocalDir = $mosConfig_absolute_path . "/noah_pics/cats";
//Isto agora  gradado na base de dados
//$variableFieldsNum=10;
	
	$noahSet = new NoahClass_Settings($database);
	$noahSet->getSettings();
	
	$variableFieldsNum = $noahSet->numfields;

$fUsingPaymentSystem = false;
if ($noahSet->payclasspath != "") {
	$payclassfullpath = $mosConfig_absolute_path . "/components/" . $noahSet->payclasspath;
	if (file_exists($payclassfullpath)) {
		require_once($payclassfullpath . "/payment.php");
		$fUsingPaymentSystem = true;
	}
}

// O nmero de colunas de categorias  definido aqui:
$categoryColumnsNum=2;
//$otherTemplate=1;  // Se voc retirar o comentrio desta linha, o componente adotar o template1.php para exibir as pginas.

// PRIVATIVO - No altere o restante deste arquivo:
$applName = "#__classifieds";

$blockSortDirection="lastBlockLast";

$dbClasses[]="globalsettings";
$dbClasses[]="globalstat";
$dbClasses[]="varfields";
$dbClasses["search"]="classifiedssearch";

$allowedMethods["showemails"]='$base->showEmails($s);';
$allowedMethods["prolong_expiration"]='$base->prolongExpiration();';
$allowedMethods["approve"]='$base->approve();';
$allowedMethods["clearPayment"]='$base->clearPayment()';
$allowedMethods["modifydetails_form"]='$base->modifyDetailsForm($s);';
$allowedMethods["modifydetails"]='$base->modify();';
$allowedMethods["checkconf"]='$s=checkConf();';
$allowedMethods["remove_first_check"]='$s=removeFirstCheck();';
$allowedMethods["payment_processed"]='paymentProcessed();';
$allowedMethods["customer_return"]='customerReturn();';
$allowedMethods["callback_failed"]='callbackFailed();';

$categoryClassName = "classifiedscategory";
$itemClassName = "advertisement";
$initClassName = "classifiedsinit";
$searchClassName = "classifiedssearch";
$shoppingCartClassName = "shoppingcart";

//$webSiteUrl="http://phpoutsourcing.com";
$showIcon = FALSE;
$methodsInHead=TRUE;
$noTreeIdx = TRUE;
$headerAlign="left";
$showExplanation=1; //Explanation_no
if( !isset($rangeBlockSize) ) $rangeBlockSize=10; 
$fixCss=$stNoahHttpDir . "style.css";
$saveSearchSupport=FALSE;
$list2Colors=0;
if (!isset($showPicInList)) $showPicInList=TRUE;
//$registrationType = 2;
$defaultMethod = "showhtmllist";
$defaultList = $categoryClassName;
$defaultRollId = 0;
$withShoppingCart = FALSE;
$currency = '$';
if( $withShoppingCart ) $dbClasses["shoppingcart"]="shoppingcart";

// Cronjobok (az intallibben ilyen id-vel letre kell hozni a megfelelo
// cronjob objektumokat):
define("Cronjob_checkExpiration", 1);
define("Cronjob_deleteExpired", 2);

// Ezeket azert indexeljuk hogy a harmadik szinten konnyen felulirhatok
// legyenek:
$dbClasses["category"]="classifiedscategory";
$dbClasses["advertisement"]="advertisement";

// Notificationok (az intallibben ilyen id-vel letre kell hozni a megf.
// notification objektumokat):
define("Notification_adCreated", 101);
define("Notification_adDeleted", 102);
define("Notification_adExpired", 103);
define("Notification_adApproved", 104);
define("Notification_adReply", 105);
define("Notification_adToAFriend", 106);
define("Notification_adRejected", 107);
define("Notification_newPurchase", 108);
define("Notification_adApprovedPaymentPending", 109);

// Varfields tipusok:
define("varfields_text", 1);
define("varfields_textarea", 2);
define("varfields_bool", 3);
define("varfields_selection", 4);
define("varfields_separator", 5);
define("varfields_multipleselection", 6);
define("varfields_checkbox", 7);

define("search_allFields",1);
define("search_anyFields",2);

define("Init_adminhelp",110);
define("Init_confcheck",111);
define("Init_myCart",112);
define("Init_recentPurchases",113);
define("Init_trackPurchases",114);

define("Shoppingcart_new",1);
define("Shoppingcart_payed",2);
define("Shoppingcart_processed",3);
?>
