<?php
/**
* install.noah.php
* Traduzido por Filipe Torres em 10/10/2006
* @package Noah Classifieds Joomla!/Mambo Component
* @version 1.0
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

// Don't allow direct access
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

require_once($mosConfig_absolute_path . "/administrator/components/com_noah/dbupgrade.php");

function com_install()
{
	global $mosConfig_absolute_path, $mosConfig_live_site;
	global $applName;
	global $cronjob_typ;
	global $notification_typ;
	global $globalstat_typ;
	global $mosConfig_mailfrom;
	
?>
	<p align="center">
	Instalando o componente  Noah's Classified. Atravs da generosidade do grupo PHPOutsourcing,
	este componente  lanado sob a licena GNU/GPL. Visite-nos em: <a href='http://www.phpoutsourcing.com' target='_blank'>www.phpoutsourcing.com</a>.</p>
	<p align="center">
	O trabalho de tranform-lo em um componente para Joomla!/Mambo foi feito por David McKinnis. Visite seu website em
	<a href="http://www.davidmckinnisconsulting.com" target='_blank'>www.davidmckinnisconsulting.com</a>.
	</p>
    <p align='center'>Criando configuraes padro...</p>
    <?php

	$stNoahDir = $mosConfig_absolute_path . "/components/com_noah/";
	$stNoahHttpDir = $mosConfig_live_site . "/components/com_noah/";

	$stNoahPics = $mosConfig_absolute_path . "/noah_pics";
	
	if (!file_exists($stNoahPics)) {
	    $fDirCreate = @mkdir($stNoahPics, 0777);
	} else {
		$fDirCreate = true;
	}
	 
	$fEchoSpec = false;
	
	if ($fDirCreate !== false)  {
		@chmod($stNoahPics, 0777);
	
		if (!file_exists($stNoahPics . "/cats")) {
			$fSubDir1Create = @mkdir($stNoahPics . "/cats", 0777);
		} else { 
			$fSubDir1Create = true;
		}	
		
		if (!file_exists($stNoahPics . "/listings")) {
			$fSubDir2Create = @mkdir($stNoahPics . "/listings", 0777);
		} else {
			$fSubDir2Create = true;
		}
		
		if (!$fSubDir1Create || !$fSubDir2Create) {
			echo "<p align='center' style='color:red;font-size:14pt;font-weight:bold;'>";
			echo "Erro na criao do diretrio ";
			if (!$fSubDir1Create) {
				$stDirs = $stNoahPics . "/cats";
				if (!$fSubDir2Create) {
					$stDirs .= " and " . $stNoahPics . "/listings";
				}
			} else {
				$stDirs = $stNoahPics . "/listings";
			}
			echo $stDirs . ". Por favor, crie manualmente os diretrios $stDirs";
			$fEchoSpec = true;
		}
		
	} else {
		echo "<p align='center' style='color:red;font-size:14pt;font-weight:bold;'>";
		echo "Erro na criao do diretrio $stNoahPics. Por favor, crie manualmente os diretrios $stNoahPics, {$stNoahPics}/cats";
		echo "and {$stNoahPics}/listings";
		$fEchoSpec = true;
	}
	
	if ($fEchoSpec) {
		echo " com permisses 777 (todos podem ler, escrever e executar).</p>";
	}
	
	global $database;
	
	include_once($mosConfig_absolute_path . "/administrator/components/com_noah/noah.class.php");
	include($stNoahDir . "constants.php");
	include($stNoahDir . "gorum/gorum.php");
	include($stNoahDir . "include.php");

	$fError = false;

    $g = new globalstat;
    $g->id=1;
    
    if ($g->load("", "*", TRUE) == not_found_in_db)
    {
		$g->instver="1_3";
		$g->defPageConf=FALSE;
		create($g);
	}
	
    $c = new cronjob;
    $c->id = Cronjob_checkExpiration;
    
    if ($c->load("", "*", TRUE) == not_found_in_db)
    {
		$c->title = "Checar anncios expirados";
		$c->frequency=24; //hours
		$c->function = "checkExpiration();";
		create($c);
	}
	    
    $c = new cronjob;
    $c->id = Cronjob_deleteExpired;
    
    if ($c->load("", "*", TRUE) == not_found_in_db)
    {
		$c->title = "Apagar anncios expirados";
		$c->frequency=24; //hours
		$c->function = "deleteExpiredAds();";
		create($c);
	}
		        
    // Notificationok ( a constants.php-ban felvett id-kkel itt  
    // objektumokat krealunk):
    $n = new notification;
    $n->id = Notification_adCreated;
    
    if ($n->load("", "*", TRUE) == not_found_in_db)
    {
		$n->title = "Enviado ao administrador quando um anncio  criado ou modificado";
		$n->subject="Criao ou modificao de anncio";
		$n->body="Um novo anncio foi criado ou modificado. Title: \$title\nVoc pode visualiz-lo em:\n\$url";
		$n->variables="title, url";
		$n->active=TRUE; 
		create($n);
	}
			    
    $n = new notification;
    $n->id = Notification_adDeleted;
    
    if ($n->load("", "*", TRUE) == not_found_in_db)
    {
		$n->title = "Enviado ao autor do anncio quando seu anncio  apagado";
		$n->subject="Anncio expirado";
		$n->body="Seu anncio expirou e foi removido do nosso sistema!\n\nDetalhes do anncio:\n\tCategoria: \$category,\n\tTtulo: \$title.";
		$n->variables="category, title"; 
		create($n);
	}
		    
    $n = new notification;
    $n->id = Notification_adExpired;
    
    if ($n->load("", "*", TRUE) == not_found_in_db)
    {
		$n->title = "Enviado ao autor quando seu anncio est perto de expirar";
		$n->subject="Aviso de expirao de anncio";
		$n->body="Seu anncio ir expirar em \$daysLeft dias. Por favor, Se acesse o site http://www.veterinariaharmonia.com.br, entre com seu nome de usurio e senha, entre na seo de classificados e prolongue a veiculao do seu anncio, caso contrrio ele ser automaticamente removido do nosso sistema!\n\nDetalhes do anncio:\n\tCategoria: \$category,\n\tTtulo: \$title.";
		$n->variables="daysLeft, category, title"; 
		create($n);
	}
		    
    $n = new notification;
    $n->id = Notification_adApproved;
    if ($n->load("", "*", TRUE) == not_found_in_db)
    {
		$n->title = "Enviado ao autor quando seu anncio foi aprovado";
		$n->subject="Anncio aprovado";
		$n->body="Seu anncio com o ttulo '\$title' foi aprovado. Voc pode conferir no seguinte endereo:\n\$url";
		$n->variables="title, url";
		create($n);
	}
	    
    $n = new notification;
    $n->id = Notification_adApprovedPaymentPending;
    if ($n->load("", "*", TRUE) == not_found_in_db)
    {
		$n->title = "Enviado ao autor quando seu anncio foi aprovado e est com pagamento pendente";
		$n->subject="Anncio aprovado - Aguardando pagamento";
		$n->body="Seu anncio com o ttulo '\$title' foi aprovado. Quando o pagamento tiver sido efetuado, ele ficar visvel. Voc vai poder conferir no seguinte endereo:\n\$url";
		$n->variables="title, url";
		create($n);
	}

    $n = new notification;
    $n->id = Notification_adRejected;
    
    if ($n->load("", "*", TRUE) == not_found_in_db)
    {
		$n->title = "Enviado ao autor quando seu anncio foi rejeitado";
		$n->subject="Anncio rejeitado";
		$n->body="Seu anncio foi rejeitado. Os detalhes do anncio so:\n\tTtulo: \$title\n\tDescrio: \$description\n\nPara mais informaes, contacte o administrador do sistema!";
		$n->variables="title, description";
		create($n);
	}
		    
    $n = new notification;
    $n->id = Notification_adReply;
    
    if ($n->load("", "*", TRUE) == not_found_in_db)
    {
		$n->title = "Resposta para uma mensagem";
		$n->subject="Resposta  sua mensagem";
		$n->body="Obrigado por usar o nosso sistema!\n\nO que segue  a resposta  mensagem '\$listing', enviada atravs do nosso site:\n\n\$url\nInformae sobre a pessoa:\nNome: \$name\nEmail: \$email\n===========================================\n\$message\n\n===========================================\nPara responder esta mensagem, clique na opo de 'Responder' de seu programa de email ou do seu webmail.\n===========================================";
		$n->variables="listing, url, name, email, message"; 
		create($n);
	}
			    
    $n = new notification;
    $n->id = Notification_adToAFriend;
    
    if ($n->load("", "*", TRUE) == not_found_in_db)
    {
		$n->title = "Mensagem de um amigo";
		$n->subject="Mensagem de um amigo";
		$n->body="Seu amigo \$name enviou este link para voc:\n\n===========================================\n\$url\n===========================================\nMensagem:\n\$message\n===========================================";
		$n->variables="name, url, message"; 
		create($n);
	}
	    
    if( $withShoppingCart )
    {
        $n = new notification;
        $n->id = Notification_newPurchase;
    
		if ($n->load("", "*", TRUE) == not_found_in_db)
		{
			$n->title = "Enviado ao administrador quando uma nova compra foi sugerida";
			$n->subject="Nova compra";
			$n->body="\$name fez uma nova oferta de compra. Voc pode ver os detalhes do usurio em:\n\$userUrl\n\nVoc pode ver os detalhes da proposta em:\n\$orderUrl\n\n";
			$n->variables="name, userUrl, orderUrl"; 
			$n->fixRecipent=TRUE;
			$n->recipent = $adminEmail;
			create($n);
	    }
	}

	if (!Noah_FUpgradeDatabaseTables($errMsg)) {
		echo "<p>$errMsg</p>";
	}

	echo "<center>\n<table width=\"100%\" border=\"0\">\n<tr><td>";
	if ($fError)
		echo "Erro na instalaodo componente Noah Classifieds.</td></tr><tr><td>$msg</td>";
	else
	{
		echo "O componente Noah Classifieds foi instalado com sucesso!</td><tr><td>";
		echo "Um vez que voc crie um item no menu para o Noah Classifieds, voc deve ir ao frontend do site e criar algumas categorias para os anncios.";
		echo "</td>";
	}

	echo "</tr>\n</table></center>";
}	
?>