<?php
/**
* template1.php
* @package Noah Classifieds Mambo Component
* @version 1.0
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* @traduo para portugus: Filipe Torres
*/

// Don't allow direct access
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

/*
Este  um arquivo de template para o aplicativo de classificados.
Se voc no  um programador, no ser fcil modific-lo.
Se voc  um programador, ser fcil modific-lo.

Ns achamos desnecessrio uma explicao aprofundada sobre o qu e onde
vo deve alterar. Os nomes das funes e variveis exibem
suas regras.

Todas as funes tm alguns parmetros de entrada (input parameters) e produzem uma seqncia de caracteres (string) chamada $s
que ser enviada de volta  funo que a requisitou (caller function) como um valor retornado.

Sinta-se livre para modificar as funes e dar uma melhor aparncia ao seu componente.
No esquea de mudar a folha de estilos no arquivo style.css
se voc quiser modificar as cores.
*/
$catColors[0][0]="#999900";
$catColors[0][1]="#cccc66";
$catColors[1][0]="#ff9900";
$catColors[1][1]="#ffcc99";
$catColors[2][0]="#cc6600";
$catColors[2][1]="#e6b380";
$catColors[3][0]="#cc9933";
$catColors[3][1]="#ffcc66";
$catSp="7";
function templateMain($userMenuStr,$adminMenuStr,$userStatus,
                      $navBarText,$infoText,$gorumcontent,$footer)
{
/*
Descrio:
    Esta  a principal funo de exibio.
Parmetros de entrada (input parameters):
    Os nomes dos parmetros mostram qual parte da pgina contida
    seqncia de caracteres (strings).
    $gorumcontent  a parte principal da pgina gerada pelo programa.
*/
    global $xi;
    $s="";

    $s.="<center>";
    $s.="<span class='userstatus'>$userStatus</span>\n";
    $s.=vertSpacer("3");
    $s.=$userMenuStr;
    if ($adminMenuStr) {
        $s.=vertSpacer("3");
        $s.=$adminMenuStr;
    }
    if ($navBarText) {
        $s.=vertSpacer("30");
        $s.="<table border='0' cellpadding='0' cellspacing='0'>";
        $s.="<tr>";
        $s.="<td><img src='$xi/b.gif' width='15'></td>\n";
        $s.="<td class='navBar'>$navBarText";
        $s.="</td></tr></table>\n";
    }
    if( $infoText ) {
        $s.=vertSpacer();
        $s.=templateShowAppInfoText($infoText)."\n";
    }
    if ($navBarText) {
        $s.=vertSpacer();
    }
    else {
        $s.=vertSpacer(42);
    }
    $s.=$gorumcontent;
    $s.=vertSpacer("20");
    $s.=templateShowVersionFooter();
    return $s;
}

function templateShowAppInfoText($txt)
{
/*
Descrio:
    Esta funo exibir o resultado de uma operao feita 
    has made. Ex: clicando em um boto tal como Cancelar, OK etc.
Parmetros de entrada (input parameters):
    O texto da mensagem a ser exibida.
*/
    global $xi;
    $s="";
    $s.="<span class='infoText'>$txt</span>\n";
    return $s;
}
function templateShowVersionFooter()
{
    global $gorumglobalstat,$lll;
    $s="";
    $s.=vertSpacer();
    $s.="<center><span class='powfooter'>Powered by ".
        "<a href='http://classifieds.phpoutsourcing.com/' class='powfooter'>".
        "Noah's Classifieds</a> ";
    $s.=str_replace("_", ".", $gorumglobalstat->instver);
    $s.=" - <a href='http://classifieds.phpoutsourcing.com/donate.php'".
        " class='powfooter'>Donate Noah's Classifieds</a>";
    $s.="</span></center>";
    return $s;
}
function templateShowMenu($menu)
{
/*
Descrio:
    Os itens do menu sero exibidos.
Parmetros de entrada (input parameters):
    Matriz (Array). Os elementos da matriz so os itens do menu.
*/
    global $xi;

    $s="";
    $s.="<table border='0' cellpadding='0' cellspacing='0'>";
    $s.="<tr valign='middle'>";
    $first=TRUE;
    foreach($menu as $id=>$menuPoint) {
        if (!$first) {
            $s.="<td>\n";
            $s.="&nbsp;";
            $s.="</td>";
            $s.="<td align='center' valign='middle'>";
            $s.="<img src='$xi/menusep.gif' width='8' height='8'>";
            $s.="</td>";
            $s.="<td>\n";
            $s.="&nbsp;\n";
            $s.="</td>";
        }
        $s.="<td class='mainmenu' nowrap>\n";
        $s.=$menuPoint;
        $s.="</td>\n";
        $first=FALSE;
    }
    $s.="</td></tr>";
    $s.="</table>";
    return $s;
}
function templateShowCat($catArr,$adListStr)
{
/*
Descrio:
    Exibe as categorias.
Parmetros de entrada (input parameters):
    $catArr: Matriz (Array). Os elementos da matriz so os objetos categoria.
             O formato dos objetos  descrito na
             funo templateShowOneCat.
    $adListStr: A seqncia de caracteres (string) para adicionar novos itens  categoria.
*/
    global $xi,$catColors;
    $s="";
    $colNum=4;
    $s.="<table border='0' cellpadding='0' cellspacing='0'>";
    $s.="<tr>";
    $i=0;
    foreach($catArr as $item) {
        if (($i % $colNum) == 0) $s.="<tr>";        
        $s.="<td><img src='$xi/b.gif' width='2'></td>";
        $s.="<td valign='top'>";
        $s.=templateShowOneCat($item);
        $s.="</td>\n";
        if ((($i+1) % $colNum) == 0) {
            $s.="</tr>\n<tr><td colspan='$colNum'><img src='$xi/b.gif' height='2'></td></tr>\n";
        }
        $i++;
    }
    while ((($i+1) % $colNum) == 0) {
        $s.="<td>&nbsp;</td></tr>\n";
        $i++;
    }
    $s.="</tr>";
    $s.="</table>\n";
    $s.=vertSpacer();
    $s.=$adListStr;
    return $s;
}
function templateShowOneCat($cat)
{
/*
Descrio:
    Exibe uma categoria.
Parmetros de entrada (input parameters):
    $cat: objeto.
            Campos: title, description, pic.
*/
    $s="";
    $s.="<table border='0'>";
    $s.="<tr><td class='categ'>$cat->title</td></tr>\n";
    $s.="<tr><td class='catdesc'>$cat->description</td></tr>\n";
    if ($cat->pic) {
        $s.="<tr><td class='catdesc'>$cat->pic</td></tr>\n";
    }
    $s.="</table>\n";
    return $s;
}
?>
